#!/usr/bin/env node

const path = require('path')
const fs = require('fs')
const minimist = require('minimist')
const getTmp = require('../libs/getTemplate')
const args = minimist(process.argv.slice(2))
console.log('args:', args)
if (args.o && typeof args.o == 'string') {
  let fpath = ''

  const currentPath = path.resolve()
  if (!args.o.match('^((/[a-zA-Z0-9-_]+)+|/)$')) {
    console.log('路径输入错误 格式:/pages/list/list/')
    return;
  }
  if (args.o.substr(-1) === '/') {
    args.o = args.o.substr(0, args.o.length - 1)
  }

  if (args.o[0] === '/') {
    fpath = currentPath + args.o
  } else {
    fpath = currentPath + '/' + args.o
  }

  console.log('fpath:', fpath)
  if (!fs.existsSync(fpath)) {
    mkdirsSync(fpath) // 创建目录

    let wxssContent = getTmp.getTemplate('wechat.wxss')
    // console.log('wxssContent:', wxssContent)
    fs.writeFileSync(path.join(fpath, 'index.wxss'), `/*${args.o}/index.wsss*/\n${wxssContent}`);

    let jsContent = getTmp.getTemplate('wechat.js')
    fs.writeFileSync(path.join(fpath, 'index.js'), `//${args.o}/index.js\n${jsContent}`);

    let jsonContent = getTmp.getTemplate('wechat.json')
    fs.writeFileSync(path.join(fpath, 'index.json'), `${jsonContent}`);

    let wxmlContent = getTmp.getTemplate('wechat.wxml')
    fs.writeFileSync(path.join(fpath, 'index.wxml'), `<!--${args.o}/index.wxml-->\n${wxmlContent}`);

    const appPath = currentPath + '/app.json'
    console.log('appPath:', appPath)
    if (fs.existsSync(appPath)) {
      let appContent = fs.readFileSync(appPath).toString()
      // console.log('appContent:',appContent)
      let appJson = JSON.parse(appContent)
      console.log('appJson:', appJson.pages)
      let pagePath = ''
      if (args.o[0] === '/') {
        pagePath = args.o.substring(1)
      } else {
        pagePath = args.o
      }
      pagePath = pagePath + '/index'
      console.log('pagePath:', pagePath)
      appJson.pages.push(pagePath)
      console.log('appJson:', appJson)
      let appStr = JSON.stringify(appJson, "", 2)
      fs.writeFileSync(appPath, appStr);

    }

  } else {
    console.log(`${fpath} 已存在`)
  }

} else {
  console.log('请在工程的根目录下输入要创建的路径,格式为 npx wxpath -o /pages/test 会生成 /pages/test/index.js')
}


function mkdirsSync(dirname) {
  if (fs.existsSync(dirname)) {
    return true;
  } else {
    if (mkdirsSync(path.dirname(dirname))) {
      fs.mkdirSync(dirname);
      return true;
    }
  }
}